import common
#import rewrite

from subway import util
from cherrypy.lib import cptools

def _flow(method):
    """
    Decorator which denotes that a method is a flow method. You must explicitly
    add the exposed decorator in addition to this one for security reasons.

    A flow is just a parameterless method which uses generators to yield.
    Please use flow() instead of _flow()
    """
    flowid = common._get_flowid()

    def _m(_resume=0, *args, **kwargs):
        # this is the actual cherrypy handler function
        # _resume is the magic variable which lets the server know
        # at which point in the flow the client is resuming.
        #util.no_cache()
        try:
            _resume = int(_resume)
        except:
            if method.func_name == 'index':
                raise TypeError
            raise
        gen = common._get_gen(flowid, _resume, method)
        result = gen.next() # execute the next resume point
        if result == common.MILESTONE:
            common.save_milestone(flowid, _resume)
            result = gen.next()
        common._save_resumepoint(flowid, gen)
        return result # and return the response
    #return rewrite.flow_rewrite(_m)
    _m.__doc__ = method.__doc__
    return _m

flow = lambda func: cptools.decorate(func, _flow)
