from cherrypy.lib.filter import basefilter
import subway
from urlparse import urlparse
import cherrypy

class UrlFilter(basefilter.BaseFilter):
    """
    Various URL filters.
    """
    def __init__(self):
        self.virtual_path = subway.config_get("subway.virtual_path", None)
        if self.virtual_path:
            # Clean the virtual path
            self.virtual_path = urlparse(self.virtual_path)[2]
            self.virtual_path = "/"+"/".join(filter(lambda x:x, self.virtual_path.split("/")))

    def virtual_path_filter(self):
        """
        Render a given virtual path as root path.
        Useful for running CP in non-root locations while using WSGI.
        """
        cur_path = subway.request.path
        # Remove the virtual path from the request one
        if cur_path.startswith(self.virtual_path):
            new_path = cur_path[len(self.virtual_path):]
            if not new_path.startswith("/"):
                new_path = "/"+new_path
            cherrypy.request.objectPath = new_path


    def beforeRequestBody(self):
        if self.virtual_path:
            self.virtual_path_filter()
