import formencode
from formencode import htmlfill_schemabuilder
import types
import api
import cherrypy
from cherrypy.lib.filter import basefilter
from cherrypy.lib import cptools
import cgi

class FormErrors(api.Wrapper):
    _default_return = ""
    def _get_form_errors(self):
        if not hasattr(cherrypy.threadData, "form_errors"):
            cherrypy.threadData.form_errors = {}
        return cherrypy.threadData.form_errors
    _d = property(_get_form_errors, lambda self, v: None)
    def __init__(self):
        api.Wrapper.__init__(self)        

form_errors = FormErrors()

class FormDefaults(api.Wrapper):
    def _get_form_defaults(self):
        if not hasattr(cherrypy.threadData, "form_defaults"):
            cherrypy.threadData.form_defaults = {}
        return cherrypy.threadData.form_defaults
    _d = property(_get_form_defaults, lambda self, v: None)
    def __init__(self):
        api.Wrapper.__init__(self)

form_defaults = FormDefaults()

class FormSubmitted(object):
    def __len__(self):
        return getattr(cherrypy.threadData, "form_submitted", False)

form_submitted = FormSubmitted()    

noncopy_attrs = dir(types.FunctionType)
noncopy_attrs.remove("__doc__")

def validate_form(schema, allow_extra_fields=True, state=None):
    #form_errors.clear()
    #form_defaults.clear()
    # FormEncode reports additional inputs as errors
    if api.request.args.has_key("_resume"):
        del api.request.args['_resume']
    if api.request.args:
        cherrypy.threadData.form_submitted = True
        # this loop is a pretty bad monkeypatch to add functionality
        # that formencode expects. it needs access to __len__
        if schema:
            for v in api.request.args.values():
                if isinstance(v, cgi.FieldStorage):
                    v.__len__ = lambda: 1
            try:
                return schema.to_python(api.request.args, state)
            except formencode.Invalid, e:
                errors = e.unpack_errors()
                if hasattr(errors, "keys"):
                    form_errors.update(e.unpack_errors())
                else:
                    form_errors["_all"] = errors
    return api.request.args._d

def form_handler(schema=None, allow_extra_fields=True, state=None):
    """
    Form handler for a given schema.
    schema must be a formencode schema
    allow_extra_fields will allow the function to receive
        other arguments that may not be in the schema.
    """
    def decorator(method):
        def _m(*args, **kwargs):
            kwargs = validate_form(schema, allow_extra_fields, state)
            return method(*args, **kwargs)
        return _m
    return lambda func: cptools.decorate(func, decorator)

def add_validator(name, cls):
    htmlfill_schemabuilder.default_validators[name.lower()] = cls

simple_schema = dict    
