from subway.framework import test
import subway

class Root(test.Controller):
    def _form(self):
        """
        <form name="test">
        <input type="text" name="inp" form:required="true">
        </form>
        """
        pass
        
    @subway.expose
    def form(self, **inputs):
        test.validate_form(self._form)
        if subway.form_errors:
            return subway.form_errors['_all']
        else:
            return inputs['inp']

class TestForm(test.TestCase):
    def setUp(self):
        self.start_app(Root())

    def test_docstring_form(self):
        self.assertEqual(self.request("/form", method="POST", data="extra=unexpected").body[0],
                         "The input field 'extra' was not expected.")
        self.assertEqual(self.request("/form", method="POST", data="inp=expected").body[0],
                         "expected")
